#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "util.h"
#include "ranlib.h"
#include "header.h"

void IBATCHER(int *val, int *index, int *n);

int main(int argc, char *argv[]){
  int t,u,p,points,r;
  long seed1, seed2;
  double vih, sum=0, sumsquared=0, *sample, *avg_without, jerror, jbias, average, stddev, Price_scratch[UNDERLIERS_SIZE][POINTS_SIZE];
  int i1,i,j, index[POINTS_SIZE], Max1_scratch[POINTS_SIZE], Max2_scratch[POINTS_SIZE];
  time_t now;


/*  int index[] = {3, 2, 1, 4, 5, 6, 9, 10, 7, 8};*/
/*
1, 9, 3, 7, 4, 6, 2, 8, 5, 10, 
10, 1, 2, 9, 4, 3, 7, 8, 5, 6, 
5, 6, 8, 7, 4, 9, 10, 3, 2, 1, 
*/


  for(i=0;i<POINTS_SIZE;++i){
    index[i] = i+1;
  }


  now = time(0);
  phrtsd(PHRASE,&seed1, &seed2);
  setall(SEED1, SEED2);
  
  if(argc != 15){
    exit(1);
  }

  sscanf(argv[1],"%i",&UNDERLIERS);
  sscanf(argv[2],"%i",&TIMESLICES);
  sscanf(argv[3],"%lf",&STRIKE);
  sscanf(argv[4],"%lf",&INITIAL);
  sscanf(argv[5],"%lf",&EXPIRATION);
  sscanf(argv[6],"%lf",&INTEREST); INTEREST = INTEREST*EXPIRATION/(double)(TIMESLICES-1.0);
  sscanf(argv[7],"%lf",&DIVIDEND); DIVIDEND = DIVIDEND*EXPIRATION/(double)(TIMESLICES-1.0);
  sscanf(argv[8],"%lf",&VARIANCE); VARIANCE = VARIANCE*EXPIRATION/(double)(TIMESLICES-1.0);
  sscanf(argv[9],"%i",&POINTS);
  sscanf(argv[10],"%i",&MINPOINTS);
  sscanf(argv[11],"%lf",&POWER);
  sscanf(argv[12],"%lf",&PROBCUTOFF);
  sscanf(argv[13],"%i",&MAXIGNORE);
  sscanf(argv[14],"%i",&REPETITIONS);
  
  
      
  sample = (double*)malloc(REPETITIONS*sizeof(double));
  avg_without = (double*)malloc(REPETITIONS*sizeof(double));

  for(r=0;r<REPETITIONS;++r){
    for(u=0;u<UNDERLIERS;++u){
      Price[0][u][0] = INITIAL;
      Prob[0][u][0] = 1.0/UNDERLIERS;
    }

    Max1[0][0] = 0;
    Max2[0][0] = 1;

    if(INITIAL>STRIKE){
      Value_if_exercised[0][0] = INITIAL-STRIKE;
    }else{
      Value_if_exercised[0][0] = 0;
    }

    /* Fill Price[][][], Max1[][], Max2[][], Value_if_exercised[][], last timeslice Value[][] */
    for(t=1;t<TIMESLICES;++t){
      for(u=0;u<UNDERLIERS;++u){
        Number_with_max[t][u] = 0;
      }
      Ignore[t] = 0;
      Ignore_den[t] = 0;
      init_rng(t);
      points = points_on_timeslice(t);
      for(p=0;p<points;++p){
        generate_point(t,p);
      }
    }

    for(t=0;t<TIMESLICES;++t){
      for(p=0;p<points_on_timeslice(t);++p){
	for(u=0;u<UNDERLIERS;++u){
	}
      }
    }
    

    /* sort here */
    for(t=1;t<TIMESLICES;++t){
      i = points_on_timeslice(t);
      IBATCHER(Max1[t],index,&i);
      for(i=0;i<points_on_timeslice(t);++i){
      }


      for(i=0;i<points_on_timeslice(t);++i){
        for(u=0;u<UNDERLIERS;++u){
          Price_scratch[u][i] = Price[t][u][i];
        }
        Max1_scratch[i] = Max1[t][i];
        Max2_scratch[i] = Max2[t][i];
      }
      fflush(stdout);
      for(i=0;i<points_on_timeslice(t);++i){
        for(u=0;u<UNDERLIERS;++u){
          Price[t][u][i] = Price_scratch[u][ index[i] -1];
        } 
        Max1[t][i] = Max1_scratch[ index[i] -1];
        Max2[t][i] = Max2_scratch[ index[i] -1];
      }
    }

    for(t=0;t<TIMESLICES;++t){
      for(p=0;p<points_on_timeslice(t);++p){
	for(u=0;u<UNDERLIERS;++u){
	  }
      }
    }


    for(t=1;t<TIMESLICES;++t){
      for(p=0;p<points;++p){
        Value_if_exercised[t][p] = exp(-t*INTEREST)*(Price[t][ Max1[t][p] ][p] - STRIKE);
        if(Value_if_exercised[t][p] < 0) Value_if_exercised[t][p] = 0;
      }
    }


    for(p=0;p<POINTS;++p){
      Value[TIMESLICES-1][p] = Value_if_exercised[TIMESLICES-1][p];
    }

    fflush(stdout);



    /* DEBUG */
#if DEBUG
    for(t=0;t<TIMESLICES;++t){
      points=points_on_timeslice(t);

      for(p=0;p<points;++p){

        for(u=1;u<UNDERLIERS;++u){
        }

      }
    }
#endif

    /* Fill Prob[][][] */
    /*   if(PROBCUTOFF){ */
    /*     for(t=1;t<TIMESLICES-1;++t){ */
    /*       points = points_on_timeslice(t); */
    /*       for(p=0;p<points;++p){ */
    /*   prob_of_max(t,p); */
    /*       } */
    /*     } */
    /*   }else{ */
    /*     for(t=1;t<TIMESLICES-1;++t){ */
    /*       points = points_on_timeslice(t); */
    /*       for(u=0;u<UNDERLIERS;++u){ */
    /*   for(p=0;p<points;++p){ */
    /*     Prob[t][u][p] = 1.0/(double)UNDERLIERS; */
    /*   } */
    /*       } */
    /*     }     */
    /*   } */


    /* DEBUG */
#if DEBUG
    for(t=0;t<TIMESLICES;++t){
      points = points_on_timeslice(t);
      for(p=0;p<points;++p){
        for(u=1;u<UNDERLIERS;++u){
        }
      }
    }
#endif

    /* Fill Value[][] */
    for(t=TIMESLICES-2;t>0;--t){
      points = points_on_timeslice(t);
      for(p=0;p<points;++p){
        for(u=0;u<UNDERLIERS;++u){
          Prob[t][u][p] = 1.0;
        }
        vih = mesh_estimate_3(t,p);
        if(i1 = generate_mask(t,p) > 0){
          vih = mesh_estimate_3(t,p);
        }
        if(vih > Value_if_exercised[t][p]){
          Value[t][p] = vih;
        }else{
          Value[t][p] = Value_if_exercised[t][p];
        }
      }
    }
    vih = mesh_estimate_3(0,0);
  
    if(vih > Value_if_exercised[0][0]){
      Value[0][0] = vih;
    }else{
      Value[0][0] = Value_if_exercised[0][0];
    }

    sum += Value[0][0];
    sumsquared += Value[0][0]*Value[0][0];
    sample[r] = Value[0][0];

    /* DEBUG */
#if DEBUG
    for(t=0;t<TIMESLICES;++t){
      points=points_on_timeslice(t);

      for(p=0;p<points;++p){
      }
    }
#endif


    for(t=0;t<TIMESLICES-1;++t){
    }
  }

  average = sum/(double)REPETITIONS;
  stddev = 1.0/sqrt((double)REPETITIONS-1)* sqrt( (sumsquared/(double)REPETITIONS) - (sum/(double)REPETITIONS)*(sum/(double)REPETITIONS));
  

  /*   for(i=i;i<REPETITIONS;++i){ */
  /*     avg_without[i] = 0; */
  /*     for(j=0;j<REPETITIONS;++j){ */
  /*       if(i != j) avg_without[i] += sample[j]; */
  /*     } */
  /*     avg_without[i] /= (REPETITIONS-1); */
  /*   } */

  /*   jerror = 0; */
  /*   for(i=0;i<REPETITIONS;++i){ */
  /*     jerror += (average - avg_without[i])*(average - avg_without[i]); */
  /*   } */
  /*   jerror = sqrt( ((double)REPETITIONS-1.0)/(double)REPETITIONS*jerror); */

  /*   jbias = 0; */
  /*   for(i=0;i<REPETITIONS;++i){ */
  /*     jbias += avg_without[i]; */
  /*   } */
  /*   jbias /= REPETITIONS; */

  /*   jbias = ((double)REPETITIONS-1.0)*(jbias-average); */


}

int points_on_timeslice(int t){
  int c;

  c = (POINTS-MINPOINTS)/pow(EXPIRATION,POWER);
  return(MINPOINTS + c*pow(EXPIRATION*(double)t/(TIMESLICES-1),POWER));
}

 
